HYSBZ 2243 树链剖分(区间更新,区间查询)较难

http://www.lydsy.com/JudgeOnline/problem.php?id=2243

Description

给定一棵有n个节点的无根树和m个操作,操作有2类:

1、将节点a到节点b路径上所有点都染成颜色c;

2、询问节点a到节点b路径上的颜色段数量(连续相同颜色被认为是同一段),如“112221”由3段组成:“11”、“222”和“1”。

请你写一个程序依次完成这m个操作。

Input

第一行包含2个整数n和m,分别表示节点数和操作数;

第二行包含n个正整数表示n个节点的初始颜色

下面 行每行包含两个整数x和y,表示xy之间有一条无向边。

下面 行每行描述一个操作:

“C a b c”表示这是一个染色操作,把节点a到节点b路径上所有点(包括a和b)都染成颜色c;

“Q a b”表示这是一个询问操作,询问节点a到节点b(包括a和b)路径上的颜色段数量。

Output

对于每个询问操作,输出一行答案。

Sample Input

6 5

2 2 1 2 1 1

1 2

1 3

2 4

2 5

2 6

Q 3 5

C 2 1 1

Q 3 5

C 5 1 2

Q 3 5

Sample Output

3

1

2

HINT

数N<=10^5,操作数M<=10^5,所有的颜色C为整数且在[0, 10^9]之间。

/***
HYSBZ 2243 树链剖分(区间更新,区间查询)
解题思路:这道题转化成线段树后需要维护三个值:区间左边界的颜色,区间右边界的颜色,区间的颜色段数。在树查询的时候要注意排重的技巧,详见代码
*/
#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <iostream>
using namespace std;
const int maxn=100005;
int fa[maxn],dep[maxn],siz[maxn],son[maxn],num[maxn],top[maxn];
int n,p,z,a[maxn],Hash[maxn];
int ll[maxn*4],rr[maxn*4],tree[maxn*4],flag[maxn*4];
int head[maxn],ip;

void init()
{
    memset(head,-1,sizeof(head));
    ip=0;
}

struct note
{
    int v,next;
} edge[maxn*2];

void addedge(int u,int v)
{
    edge[ip].v=v,edge[ip].next=head[u],head[u]=ip++;
}

void dfs(int u,int pre)
{
    son[u]=0,siz[u]=1,dep[u]=dep[pre]+1,fa[u]=pre;
    for(int i=head[u]; i!=-1; i=edge[i].next)
    {
        int v=edge[i].v;
        if(v==pre)continue;
        dfs(v,u);
        siz[u]+=siz[v];
        if(siz[son[u]]<siz[v])
            son[u]=v;
    }
   // printf("%d fa dep son siz %d %d %d %d\n",u,fa[u],dep[u],son[u],siz[u]);
}
void init_que(int u ,int tp)
{
    num[u]=++z,top[u]=tp,Hash[z]=u;
    if(son[u])
    {
        init_que(son[u],tp);
    }
    for(int i=head[u]; i!=-1; i=edge[i].next)
    {
        int v=edge[i].v;
        if(v==fa[u]||v==son[u])continue;
        init_que(v,v);
    }
    //printf("%d num top %d %d\n",u,num[u],top[u]);
}
void push_down(int root)
{
    if(flag[root])
    {
        tree[root<<1]=tree[root<<1|1]=1;
        ll[root<<1]=ll[root<<1|1]=rr[root<<1]=rr[root<<1|1]=ll[root];
        flag[root<<1]=flag[root<<1|1]=1;
        flag[root]=0;
    }
}

void push_up(int root)
{
    if(ll[root<<1|1]==rr[root<<1])
        tree[root]=tree[root<<1]+tree[root<<1|1]-1;
    else
        tree[root]=tree[root<<1]+tree[root<<1|1];
    ll[root]=ll[root<<1];
    rr[root]=rr[root<<1|1];
}

void build(int root,int l,int r)
{
    flag[root]=0;
    if(l==r)
    {
        tree[root]=1;
        ll[root]=rr[root]=a[Hash[l]];
        return;
    }
    int mid=(l+r)>>1;
    build(root<<1,l,mid);
    build(root<<1|1,mid+1,r);
    push_up(root);
}
void update(int root,int l,int r,int x,int y,int z)
{
    if(l>y||r<x)return;
    if(x<=l&&r<=y)
    {
        flag[root]=1;
        tree[root]=1;
        ll[root]=z;
        rr[root]=z;
        return;
    }
    push_down(root);
    int mid=(l+r)>>1;
    update(root<<1,l,mid,x,y,z);
    update(root<<1|1,mid+1,r,x,y,z);
    push_up(root);
}
int query(int root,int l,int r,int x,int y)
{
    if(x<=l&&r<=y)
    {
        return tree[root];
    }
    push_down(root);
    int sum=0;
    int mid=(l+r)>>1;
    if(y<=mid)
        return query(root<<1,l,mid,x,y);
    else if(x>mid)
        return query(root<<1|1,mid+1,r,x,y);
    else
    {
        int sum=query(root<<1|1,mid+1,r,x,y)+query(root<<1,l,mid,x,y);
        if(ll[root<<1|1]==rr[root<<1])
            sum--;
        return sum;
    }
}

int query1(int root,int l,int r,int loc)
{
    if(l==r)
    {
        return ll[root];
    }
    push_down(root);
    int mid=(l+r)>>1;
    if(loc<=mid)
        return query1(root<<1,l,mid,loc);
    else
        return query1(root<<1|1,mid+1,r,loc);
}
int main()
{
  //  freopen("data.txt","r",stdin);
    while(~scanf("%d%d",&n,&p))
    {
        for(int i=1; i<=n; i++)
        {
            scanf("%d",&a[i]);
        }
        init();
        for(int i=1; i<n; i++)
        {
            int x,y;
            scanf("%d%d",&x,&y);
            addedge(x,y);
            addedge(y,x);
        }
        z=0,siz[0]=0,dep[0]=0;
        dfs(1,0);
        init_que(1,1);
        build(1,1,z);
        while(p--)
        {
            char s[10];
            int x,y,zz;
            scanf("%s",s);
            if(s[0]=='Q')
            {
                scanf("%d%d",&x,&y);
                int f1=top[x],f2=top[y],sum=0;
                while(f1!=f2)
                {
                    if(dep[f1]<dep[f2])
                    {
                        swap(f1,f2);
                        swap(x,y);
                    }
                    sum+=query(1,1,z,num[f1],num[x]);
                    if(query1(1,1,z,num[f1])==query1(1,1,z,num[fa[f1]]))
                    {
                        sum--;
                    }
                    x=fa[f1],f1=top[x];
                }
                if(dep[x]>dep[y])
                    swap(x,y);
                sum+=query(1,1,z,num[x],num[y]);
                printf("%d\n",sum);
            }
            else
            {
                scanf("%d%d%d",&x,&y,&zz);
                int f1=top[x],f2=top[y];
                while(f1!=f2)
                {
                    if(dep[f1]<dep[f2])
                    {
                        swap(f1,f2);
                        swap(x,y);
                    }
                    update(1,1,z,num[f1],num[x],zz);
                    x=fa[f1],f1=top[x];
                }
                if(dep[x]>dep[y])
                    swap(x,y);
                update(1,1,z,num[x],num[y],zz);
            }
        }
    }
    return 0;
}
时间: 2024-10-07 00:56:23

HYSBZ 2243 树链剖分(区间更新,区间查询)较难的相关文章

HYSBZ 2243 树链剖分

点击打开链接 题意:中文 思路:一看就是应该用树链剖分与线段树的结束,主要是结合什么呢,因为需要连续的一段一段的,所以我们肯定是要用区间合并,那么区间合并需要用到什么呢,就是整个区间的最左端和最右端的元素及这个区间已经形成的段数,那么我们合并的时候就要判断一下左儿子的最右端与右儿子的最左端是不是相同,然后在处理,而更新就用个懒惰标记就可以完成了,而查询一段是与正常的区间合并是一样的,但是因为是树链剖分,将路径结合到线段树的部分是有一部分的区间是有联合的,所以我们不能直接将和加起来,还是要判断一下

HYSBZ - 2243 树链剖分 + 线段树 处理树上颜色段数

用线段树处理颜色段数 记录区间内的颜色段数,区间右端点的颜色,区间右端点的颜色. int tr[maxn<<2], lc[maxn<<2], rc[maxn<<2]; 懒标记,记录区间是否被覆盖 int lazy[maxn<<2]; 合并的方法是这样,对于某一区间 ? 如果 左区间的右端点颜色 == 右区间的左端点 ? 那么 这左右区间合并,左区间的最右边一段和右区间最左边一段颜色是连续的,那么区间的颜色段数为 左区间颜色段数+右区间颜色段数 - 1. ?

HYSBZ 1036 树链剖分(单点更新区间求和求最大值)

http://www.lydsy.com/JudgeOnline/problem.php?id=1036 Description 一棵树上有n个节点,编号分别为1到n,每个节点都有一个权值w.我们将以下面的形式来要求你对这棵树完成一些操作: I. CHANGE u t : 把结点u的权值改为t II. QMAX u v: 询问从点u到点v的路径上的节点的最大权值 III. QSUM u v: 询问从点u到点v的路径上的节点的权值和 注意:从点u到点v的路径上的节点包括u和v本身 Input 输入

POJ 1195-Mobile phones(二维树状数组-区间更新区间查询)

Mobile phones Time Limit: 5000MS   Memory Limit: 65536K Total Submissions: 17661   Accepted: 8173 Description Suppose that the fourth generation mobile phone base stations in the Tampere area operate as follows. The area is divided into squares. The

BZOJ 2243:染色(树链剖分+区间合并线段树)

[SDOI2011]染色Description给定一棵有n个节点的无根树和m个操作,操作有2类:1.将节点a到节点b路径上所有点都染成颜色c:2.询问节点a到节点b路径上的颜色段数量(连续相同颜色被认为是同一段),如“112221”由3段组成:“11”.“222”和“1”.请你写一个程序依次完成这m个操作.Input第一行包含2个整数n和m,分别表示节点数和操作数:第二行包含n个正整数表示n个节点的初始颜色下面 行每行包含两个整数x和y,表示x和y之间有一条无向边.下面 行每行描述一个操作:“C

SPOJ - QTREE(树链剖分+单点更新+区间最大值查询)

题意:给出n个点n-1条边的树,有两个操作,一个是查询节点l到r的边的最大值,然后指定边的更改权值. 题解:差不多是树链剖分的模版题,注意每个点表示的边是连向其父亲节点的边. #include <iostream> #include <cstring> #include <cstdio> using namespace std; const int M = 1e4 + 10; struct Edge { int v , next; }edge[M << 1]

BZOJ 2243 树链剖分

题目链接:http://www.lydsy.com/JudgeOnline/problem.php?id=2243 题意:中文题目 思路:树链剖分.首先考虑求区间颜色段数的问题, 我们可以用线段树维护:区间左右端点(st,ed),区间颜色段数(val),懒惰标记(lazy:是否整个区间被染成同一种颜色),区间左右端点的颜色(lcolor,rcolor),然后在查询的时候如果当前区间的左子树的右端点的颜色等于右子树的左端点的颜色,那么查询答案要减一.由于树链剖分在查询时是有可能两端的分链一起向上爬

HDU 5274 Dylans loves tree(LCA+dfs时间戳+成段更新 OR 树链剖分+单点更新)

Problem Description Dylans is given a tree with N nodes. All nodes have a value A[i].Nodes on tree is numbered by 1∼N. Then he is given Q questions like that: ①0 x y:change node x′s value to y ②1 x y:For all the value in the path from x to y,do they

bzoj2243树链剖分+区间合并

树链上区间合并的问题比区间修改要复杂,因为每一条重链在线段树上分布一般都是不连续的,所以在进行链上操作时要手动将其合并起来,维护两个端点值 处理时的方向问题:lca->u是一个方向,lca->v是另一个方向,到最后合并这两个放向时都看左端点即可 #include<cstring> #include<string> #include<iostream> #include<queue> #include<cstdio> #include&